# Less Retarded Software

Less retarded software (LRS) is a specific kind of [software](software.md) aiming to be a truly good technology maximally benefiting and respecting its users, following the philosophy of extreme [minimalism](minimalism.md) ([Unix philosophy](unix_philosophy.md), [suckless](suckless.md), [KISS](kiss.md)) and [freedom](free_software.md). The term was invented by [drummyfish](drummyfish.md).

## Definition

The definition here is not strict but rather fuzzy, it is in a form of ideas, style and common practices that together help us subjectively identify software as less retarded.

[Software](software.md) is less retarded if it adheres, to a high-degree (not necessarily fully), to the following principles:

- Being made with a [**truly selfless**](selfless.md) goal of maximally helping all living beings who may use the software without any intent of taking advantage of them in any way.
- Trying to follow the [Unix philosophy](unix_philosophy.md) (do one thing well, use text interfaces, ...).
- Trying to follow the [suckless](suckless.md) philosophy (configs as source files, distributing in source form, ...).
- Being [minimalist](minimalism.md) ([single compilation unit](single_compilation_unit.md), [header-only](header_only.md) libraries, no build systems, no [OOP](oop.md) languages, ...), countercomplex, [KISS](kiss.md).
- Being [free software](free_software.md) legally but ALSO practically (well commented, not bloated and obscured etc., so as to truly and practically enable the freedoms to study, modify etc.).
- Being [free culture](free_culture.md), i.e. LRS programs are free as a whole, including art assets, data etc.
- Minimizing [dependencies](dependency.md), even those such as standard library or relying on OS concepts such as files or threads, even indirect ones such as build systems and even non-software ones (e.g. avoiding [floating point](float.md), GPU, 64bit etc.).
- Very portable, non-discriminating, i.e. being written in a portable language (C etc.), using as little resources as possible (RAM, CPU, ...) and so on.
- [Future-proof](future_proof.md), [self-contained](self_contained.md), not controlled by anyone (should follow from other points).
- [Hacking](hacking.md) friendly and inviting to improvements and customization.
- Built on top of other LRS technology such as the [C99](c.md) language, Unix OS, our own libraries etc.
- Simple permissive licensing (being suckless legally) with great preference of [public domain](public_domain.md), e.g. with [CC0](cc0.md) + patent [waivers](waiver.md).
- Elegant by its simple, well thought-through solutions. (This is to be contrasted with modern rapid development.)
- No [bullshit](bullshit.md) such as [codes of conduct](coc.md), tricky licensing conditions etc.

## Specific Software

The "official" LRS programs and libraries have so far been solely developed by [drummyfish](drummyfish.md), the "founder" of LRS. These include:

- [Anarch](anarch.md): Game similar to [Doom](doom.md).
- [raycastlib](raycastlib.md): Advanced 2D [raycasting](raycasting.md) rendering library.
- [SAF](saf.md): Tiny library for small portable games.
- [small3dlib](small3dlib.md): Simple software rasterizer for 3D rendering.
- [smallchesslib](smallchesslib.md): Simple [chess](chess.md) library and engine ([AI](ai.md)).

Apart from this software a lot of other software developed by other people and groups can be considered LRS, at least to a high degree (there is usually some minor inferiority e.g. in licensing). Especially [suckless](suckless.md) software mostly fits the LRS criteria. The following programs and libraries can be considered LRS at least to some degree:

- [brainfuck](brainfuck.md)
- [dwm](dwm.md)
- [OpenBSD](openbsd.md)
- [LIL](lil.md)
- [lisp](lisp.md)
- [st](st.md)
- [badwolf](badwolf.md)
- [surf](surf.md)
- [tcc](tcc.md)
- [vim](vim.md)

It is also possible to talk about LRS data formats, standards, designs and concepts as such etc. These might include:

- [ASCII](ascii.md)
- [bytebeat](bytebeat.md)
- [farbfeld](farbfeld.md)
- [json](json.md)
- [lambda calculus](lambda_calculus.md)
- [markdown](markdown.md)
- [ppm](ppm.md)
- [reverse polish notation](rpn.md) as opposed to traditional expression notation with brackets, operator precedence and other bloat
- [set theory](set_theory.md)
- [textboards](textboard.md) and [imageboards](imageboard.md) as opposed to [forums](forum.md) (no registration, no users, simple interface)
- [turing machine](turing_machine.md)